Scriptname DeathlessSprintJump2 extends Quest

Actor Property PlayerRef  Auto
GlobalVariable Property SprintJumpAbility  Auto
;GlobalVariable Property NormalJumpHeight  Auto
;GlobalVariable Property BoostedJumpHeight  Auto
;GlobalVariable Property CalcRate  Auto

Int Property JumpKey auto
Int Property SprintKey auto
Int Property ForwardKey auto
Bool Property Init = False auto
Bool Property Sprinting = False auto
Bool Property Moving = False auto
Bool Property Working = False auto

;Int JumpKey
;Int SprintKey
;Int ForwardKey
;Bool Init = False
;Bool Sprinting = False
;Bool Moving = False
;Bool Working = False

float JumpNormal
float JumpBoost

Event OnInit()
	if !Init
		Init = True
		SprintKey = Input.GetMappedKey("Sprint")
		JumpKey = Input.GetMappedKey("Jump")
		ForwardKey = Input.GetMappedKey("Forward")
		RegisterForKey(SprintKey)
		RegisterForKey(JumpKey)
		RegisterForKey(ForwardKey)
;		RegisterForSingleUpdate(CalcRate.GetValue())
	endif
	Init = False
EndEvent

Event OnPlayerLoadGame()
	if !Init
		Init = True
		SprintKey = Input.GetMappedKey("Sprint")
		JumpKey = Input.GetMappedKey("Jump")
		ForwardKey = Input.GetMappedKey("Forward")
		RegisterForKey(SprintKey)
		RegisterForKey(JumpKey)
		RegisterForKey(ForwardKey)
;		RegisterForSingleUpdate(CalcRate.GetValue())
	endif
	Init = False
EndEvent

;=====Set Jump Boost=====
;Event OnUpdate()
;	if SprintJumpAbility.GetValue() == 1
;	bool bKeepUpdating = true
;		JumpNormal = NormalJumpHeight.GetValue()
;		JumpBoost = BoostedJumpHeight.GetValue()
;		if bKeepUpdating
;			RegisterForSingleUpdate(CalcRate.GetValue())
;		endif
;	endif
;EndEvent

;=====Jump Key pressed=====
Event OnKeyDown(Int KeyCode)
	if SprintJumpAbility.GetValue() == 1
		if KeyCode == SprintKey
			Sprinting = True
		elseif KeyCode == ForwardKey
			Moving = True
		elseif KeyCode == JumpKey && Sprinting && Moving
			if !Working
				Working = True
				SprintJump()
				Working = False
			endif
		endif
	endif
EndEvent

Event OnKeyUp(Int KeyCode, Float HoldTime)
	if SprintJumpAbility.GetValue() == 1
		if KeyCode == SprintKey
			Sprinting = False
		elseif KeyCode == ForwardKey
			Moving = False
		endif
	endif
EndEvent

;=====Sprint Jump=====
Function SprintJump()
	if PlayerRef.IsSprinting()
;		Game.SetGameSettingFloat("fJumpHeightMin", JumpBoost)
		input.ReleaseKey(SprintKey)
		input.ReleaseKey(JumpKey)
		While PlayerRef.IsSprinting()
			utility.wait(0.05)
		endwhile
;		input.TapKey(JumpKey)
		input.HoldKey(JumpKey)
		utility.wait(0.05)
		input.ReleaseKey(JumpKey)
		if input.IsKeyPressed(SprintKey)
			input.HoldKey(SprintKey)
		endif
;		Game.SetGameSettingFloat("fJumpHeightMin", JumpNormal)
	endif
EndFunction