Scriptname vvvAthleticAlias extends ReferenceAlias  

Message Property InstallMessage  Auto
Message Property UpdateMessage  Auto
Message Property NewAbilityMessage  Auto
Message Property PowerSprintMessage  Auto
GlobalVariable Property Version  Auto
GlobalVariable Property AthleticInit  Auto
GlobalVariable Property CalcRate  Auto
GlobalVariable Property PauseCalc  Auto
GlobalVariable Property JumpTraining  Auto
GlobalVariable Property SprintTraining  Auto
GlobalVariable Property SwimTraining  Auto
GlobalVariable Property Fatigue  Auto
GlobalVariable Property FatigueRate  Auto
GlobalVariable Property BodyToggle  Auto
GlobalVariable Property TrainingMult  Auto
GlobalVariable Property StaminaMult  Auto
GlobalVariable Property CheatMult  Auto
GlobalVariable Property NormalJumpHeight  Auto
GlobalVariable Property BoostedJumpHeight  Auto
GlobalVariable Property SprintJumpAbility  Auto
GlobalVariable Property SprintJumpBoostAbility  Auto
GlobalVariable Property CatchbreathAbility  Auto
GlobalVariable Property ReducedDiveDamageAbility  Auto
GlobalVariable Property SprintWaterAbility  Auto
GlobalVariable Property SprintPowerAbility  Auto
GlobalVariable Property SpeedValue  Auto
GlobalVariable Property InventoryMult  Auto
GlobalVariable Property MaxJump  Auto
GlobalVariable Property MaxSpeed  Auto
GlobalVariable Property MaxStamina  Auto
GlobalVariable Property GlobalJumpBonus  Auto
GlobalVariable Property GlobalSpeedBonus  Auto
GlobalVariable Property JumpRank  Auto
GlobalVariable Property SprintRank  Auto
GlobalVariable Property SwimRank  Auto
GlobalVariable Property JumpRankRate  Auto
GlobalVariable Property SprintRankRate  Auto
GlobalVariable Property SwimRankRate  Auto
GlobalVariable Property BVJumpBonus  Auto
GlobalVariable Property BVSpeedBonus  Auto

ReferenceAlias Property Player  Auto  
Actor Property PlayerRef  Auto
Quest Property AthleticQuest  Auto  
Quest Property AthleticQuestSprintJump  Auto
MiscObject Property SpeedToken  Auto  
Faction Property pVampirePCFaction  Auto  
MagicEffect Property pAlchFortifyCarryWeight  Auto  
MagicEffect Property pEnchFortifyCarryConstantSelf  Auto  
Spell Property Rested Auto
Spell Property WellRested Auto
FormList Property VampireRaces  Auto

Race Property pKhajiitRace  Auto  
Race Property pKhajiitRaceVampire  Auto  
Race Property pNordRace  Auto  
Race Property pNordRaceVampire  Auto  
Race Property pBretonRace  Auto  
Race Property pBretonRaceVampire  Auto  
Race Property pOrcRace  Auto  
Race Property pOrcRaceVampire  Auto  
Race Property pArgonianRace  Auto  
Race Property pArgonianRaceVampire  Auto  
Race Property pDarkElfRace  Auto  
Race Property pDarkElfRaceVampire  Auto  
Race Property pHighElfRace  Auto  
Race Property pHighElfRaceVampire  Auto  
Race Property pWoodElfRace  Auto  
Race Property pWoodElfRaceVampire  Auto  
Race Property pRedguardRace  Auto  
Race Property pRedguardRaceVampire  Auto  
Race Property pImperialRace  Auto  
Race Property pImperialRaceVampire  Auto  
Race Property pWerewolfBeastRace  Auto  

GlobalVariable Property KhajiitJumpBonus  Auto  
GlobalVariable Property NordJumpBonus  Auto  
GlobalVariable Property BretonJumpBonus  Auto  
GlobalVariable Property OrcJumpBonus  Auto  
GlobalVariable Property ArgonianJumpBonus  Auto  
GlobalVariable Property DarkElfJumpBonus  Auto  
GlobalVariable Property HighElfJumpBonus  Auto  
GlobalVariable Property WoodElfJumpBonus  Auto  
GlobalVariable Property RedguardJumpBonus  Auto  
GlobalVariable Property ImperialJumpBonus  Auto  
GlobalVariable Property WerewolfJumpBonus  Auto  
GlobalVariable Property CustomRaceJumpBonus  Auto  
GlobalVariable Property VampireJumpBonus  Auto  
GlobalVariable Property KhajiitSpeedBonus  Auto  
GlobalVariable Property NordSpeedBonus  Auto  
GlobalVariable Property BretonSpeedBonus  Auto  
GlobalVariable Property OrcSpeedBonus  Auto  
GlobalVariable Property ArgonianSpeedBonus  Auto  
GlobalVariable Property DarkElfSpeedBonus  Auto  
GlobalVariable Property HighElfSpeedBonus  Auto  
GlobalVariable Property WoodElfSpeedBonus  Auto  
GlobalVariable Property RedguardSpeedBonus  Auto  
GlobalVariable Property ImperialSpeedBonus  Auto  
GlobalVariable Property WerewolfSpeedBonus  Auto  
GlobalVariable Property CustomRaceSpeedBonus  Auto  
GlobalVariable Property VampireSpeedBonus  Auto  

int JumpKey
int SprintKey
int JumpRace
int SpeedRace
float FatigueMod
float Bodymod
float Jump
float Speed
float RestedCooldown

;=====Initialization after installation or update=====
Event OnInit()
;	debug.messagebox ("OnInit")
	GetPlayerRace()
	GetBodyWeight()
	AbilityCheck()
	JumpKey = Input.GetMappedKey("Jump")
	SprintKey = Input.GetMappedKey("Sprint")
	RegisterForKey(JumpKey)
	RegisterForKey(SprintKey)
	RegisterForSingleUpdateGameTime(0.5)
	RegisterForSingleUpdate(CalcRate.GetValue())
	if PauseCalc.GetValue() == 1
		Game.SetGameSettingFloat("fJumpHeightMin", NormalJumpHeight.GetValue())
		Game.SetGameSettingFloat("fJumpFallHeightMin", (NormalJumpHeight.GetValue()*7.895))
		PlayerRef.SetActorValue("Speedmult", SpeedValue.GetValue())
		PlayerRef.AddItem(Speedtoken, 1, true) 
		PlayerRef.RemoveItem(Speedtoken, 1, true)
	endif
	utility.wait(CalcRate.GetValue())
	float ver = Version.GetValue()
	if AthleticInit.Getvalue() != Version.GetValue()
		AthleticInit.Setvalue(Version.GetValue())
		InstallMessage.Show(ver)
	elseif AthleticInit.Getvalue() == Version.GetValue()
		UpdateMessage.Show(ver)
	endif
EndEvent

;=====Initialization after a savegame is loaded, also checks if the mod has been updated=====
Event OnPlayerLoadGame()
	;debug.messagebox ("OnPlayerLoadGame")
	if AthleticInit.Getvalue() != Version.GetValue()
		AthleticInit.Setvalue(Version.GetValue())
		AthleticQuest.Stop()
		AthleticQuest.Start()
		AthleticQuestSprintJump.Stop()
		AthleticQuestSprintJump.Start()
	endif
	if AthleticQuestSprintJump.isRunning() == 0
		AthleticQuestSprintJump.Start()
	endif
	GetPlayerRace()
	GetBodyWeight()
	AbilityCheck()
	JumpKey = Input.GetMappedKey("Jump")
	SprintKey = Input.GetMappedKey("Sprint")
	RegisterForKey(JumpKey)
	RegisterForKey(SprintKey)
	RegisterForSingleUpdateGameTime(0.5)
	RegisterForSingleUpdate(CalcRate.GetValue())
	if PauseCalc.GetValue() == 1
		Game.SetGameSettingFloat("fJumpHeightMin", NormalJumpHeight.GetValue())
		Game.SetGameSettingFloat("fJumpFallHeightMin", (NormalJumpHeight.GetValue()*7.895))
		PlayerRef.SetActorValue("Speedmult", SpeedValue.GetValue())
		PlayerRef.AddItem(Speedtoken, 1, true) 
		PlayerRef.RemoveItem(Speedtoken, 1, true)
	endif
EndEvent


bool blockcount = false
;=====Counts every jump of the player=====
Event OnKeyDown(Int KeyCode)
	if !Utility.IsInMenuMode()
		if KeyCode == JumpKey && !PlayerRef.IsSprinting() && Jump > 0 && PauseCalc.GetValue() == 0 
			if blockcount == false
				JumpTraining.SetValue(JumpTraining.GetValue() + 1)
				blockcount = true
				utility.wait(1.0)
				blockcount = false
;debug.notification("Counted to "+ JumpTraining.GetValue())
			endif
		elseif KeyCode == SprintKey && SprintPowerAbility.GetValue() == 2
			PlayerRef.SetActorValue("Speedmult", (Speed * 1.5))
			PlayerRef.AddItem(Speedtoken, 1, true) 
			PlayerRef.RemoveItem(Speedtoken, 1, true)
;debug.notification("Power Sprint! "+ (PlayerRef.GetActorValue("Speedmult")))
		endif
	endif
EndEvent

;=====Tracks overall sprinting time of the player=====
Event OnKeyUp(Int KeyCode, Float HoldTime)
	if !Utility.IsInMenuMode() && KeyCode == SprintKey && PauseCalc.GetValue() == 0 
		SprintTraining.SetValue(SprintTraining.GetValue() + Holdtime)
		if SprintPowerAbility.GetValue() == 2
		 	SprintPowerAbility.SetValue(1)
			PlayerRef.SetActorValue("Speedmult", Speed)
			PlayerRef.AddItem(Speedtoken, 1, true) 
			PlayerRef.RemoveItem(Speedtoken, 1, true)
;debug.notification("Power Sprint ended! "+ (PlayerRef.GetActorValue("Speedmult")))
		endif
	endif
EndEvent

;=====ONUPDATE EVENT=====
Event OnUpdate()
	bool bKeepUpdating = true
	if PauseCalc.GetValue() == 0
		;int Level = PlayerRef.GetLevel() as int

;=====Get Weight values=====
		int CarryWeight = PlayerRef.GetActorValue("CarryWeight") as int
		int CarryWeightBase = PlayerRef.GetBaseActorValue("CarryWeight") as int
		float InventoryWeight = PlayerRef.GetActorValue("InventoryWeight")

;=====Check if a Fortify Carry effect is applied=====
		int CWPotion = 0
		int CWEnch = 0
		int CWBoth = 0
		int CWCustom = 0
		if (PlayerRef.HasMagicEffect(pAlchFortifyCarryWeight)) && !(PlayerRef.HasMagicEffect(pEnchFortifyCarryConstantSelf))
			CWPotion = (CarryWeight - CarryWeightBase)
			if CWPotion > 200
				CWPotion = 200 ;for better compatibilty with cheat mods
			endif
		elseif !(PlayerRef.HasMagicEffect(pAlchFortifyCarryWeight)) && (PlayerRef.HasMagicEffect(pEnchFortifyCarryConstantSelf))
			CWEnch = (CarryWeight - CarryWeightBase)
			if CWEnch > 200
				CWEnch = 200
			endif
		elseif (PlayerRef.HasMagicEffect(pAlchFortifyCarryWeight)) && (PlayerRef.HasMagicEffect(pEnchFortifyCarryConstantSelf))
			CWBoth = (CarryWeight - CarryWeightBase)
			if CWBoth > 400
				CWBoth = 400
			endif
		endif

;=====Calculate Jump height, Speed, Fall height=====
		float StaminaMod
		if PlayerRef.GetActorValue("Stamina") > MaxStamina.GetValue()
			StaminaMod = (MaxStamina.GetValue()*StaminaMult.GetValue())
		else
			StaminaMod = (PlayerRef.GetActorValue("Stamina")*StaminaMult.GetValue())
		endif
		float TrainMod = TrainingMult.GetValue()
		float CheatMod = CheatMult.GetValue()
		float InventoryMod = InventoryMult.GetValue()
		float SprintTrainMod = (SprintTraining.GetValue()*0.02*TrainMod)
		float JumpTrainMod = (JumpTraining.GetValue()*0.02*TrainMod)
		float SwimTrainMod = (SwimTraining.GetValue()*0.005*TrainMod)
		Speed = (SpeedRace + StaminaMod + BodyMod + SprintTrainMod + (SwimTrainMod * 1.5) + (CWPotion*InventoryMod) + (CWEnch*InventoryMod) + (CWBoth*InventoryMod) - (InventoryWeight*InventoryMod) - FatigueMod)*CheatMod
		Jump = (JumpRace + StaminaMod + BodyMod + JumpTrainMod + SwimTrainMod + (CWPotion*InventoryMod) + (CWEnch*InventoryMod) + (CWBoth*InventoryMod) - (InventoryWeight*InventoryMod) - FatigueMod)*CheatMod
		int Fall = (260 + (Speed * 1.5) + (Jump * 2.5)) as int

;=====Set Jump and Fall height=====
		if Jump < 0.0
			Jump = 0.0
		elseif Jump > MaxJump.GetValue()
			Jump = MaxJump.GetValue()
		endif
		Game.SetGameSettingFloat("fJumpHeightMin", Jump)
		if Fall < 500
			Fall = 500
		endif
		Game.SetGameSettingFloat("fJumpFallHeightMin", Fall)

		NormalJumpHeight.SetValue(Jump)
		;BoostedJumpHeight.SetValue(Jump * SprintJumpBoostAbility.GetValue())

;=====Set Speed=====
		if InventoryWeight > CarryWeight
			PlayerRef.SetActorValue("Speedmult", 100)
		elseif Speed < 50
			PlayerRef.SetActorValue("Speedmult", 50)
		elseif Speed > MaxSpeed.GetValue() && MaxSpeed.GetValue() >= 50
			PlayerRef.SetActorValue("Speedmult", MaxSpeed.GetValue())
		else
			PlayerRef.SetActorValue("Speedmult", Speed)
		endif

;=====Update Speedmult value=====
		if SprintPowerAbility.GetValue() != 2 && !PlayerRef.IsSprinting(); Do not update while power sprinting
			PlayerRef.AddItem(Speedtoken, 1, true) 
			PlayerRef.RemoveItem(Speedtoken, 1, true)
		endif
	endif

	if bKeepUpdating
		RegisterForSingleUpdate(CalcRate.GetValue())
	endif
EndEvent


;=====Check stuff every half game hour=====
Event OnUpdateGameTime()
	bool bKeepOn = true
	if PauseCalc.GetValue() == 0
		GetPlayerRace()
		GetBodyWeight()
		CalculateFatigue()
		AbilityCheck()
		RestedCooldown -= 0.5
	endif
	if bKeepOn
		RegisterForSingleUpdateGameTime(0.5)
	endif
EndEvent


;=====Check Abilities=====
Function AbilityCheck()
	float JumpRate = JumpRankRate.GetValue()
	float JumpsCount = JumpTraining.GetValue()
	float JumpAbility
	if JumpsCount < (50*JumpRate)
		JumpAbility = 0.75
	elseif JumpsCount >= (50*JumpRate) && JumpsCount < (500*JumpRate)
		JumpAbility = 1.0
	elseif JumpsCount >= (500*JumpRate) && JumpsCount < (1500*JumpRate)
		JumpAbility = 1.25
	elseif JumpsCount >= (1500*JumpRate) && JumpsCount < (3000*JumpRate)
		JumpAbility = 1.5
	elseif JumpsCount >= (3000*JumpRate) && JumpsCount < (5000*JumpRate)
		JumpAbility = 1.75
	elseif JumpsCount >= (5000*JumpRate)
		JumpAbility = 2.0
	endif
	float SprintRate = SprintRankRate.GetValue()
	float SprintCount = SprintTraining.GetValue()
	float SprintAbility
	if SprintCount < (50*SprintRate)
		SprintAbility = 0.0
	elseif SprintCount >= (50*SprintRate) && SprintCount < (500*SprintRate)
		SprintAbility = 0.4
	elseif SprintCount >= (500*SprintRate) && SprintCount < (1500*SprintRate)
		SprintAbility = 0.8
	elseif SprintCount >= (1500*SprintRate) && SprintCount < (3000*SprintRate)
		SprintAbility = 1.2
	elseif SprintCount >= (3000*SprintRate) && SprintCount < (5000*SprintRate)
		SprintAbility = 1.6
	elseif SprintCount >= (5000*SprintRate)
		SprintAbility = 2.0
	endif
	float SwimRate = SwimRankRate.GetValue()
	float SwimCount = SwimTraining.GetValue()
	float SwimAbility
	if SwimCount < (50*SwimRate)
		SwimAbility = 0.0
	elseif SwimCount >= (50*SwimRate) && SwimCount < (500*SwimRate)
		SwimAbility = 0.2
	elseif SwimCount >= (500*SwimRate) && SwimCount < (1500*SwimRate)
		SwimAbility = 0.4
	elseif SwimCount >= (1500*SwimRate) && SwimCount < (3000*SwimRate)
		SwimAbility = 0.6
	elseif SwimCount >= (3000*SwimRate) && SwimCount < (5000*SwimRate)
		SwimAbility = 0.8
	elseif SwimCount >= (5000*SwimRate)
		SwimAbility = 1.0
	endif
	JumpRank.SetValue(JumpAbility)
	SprintRank.SetValue(SprintAbility)
	SwimRank.SetValue(SwimAbility)


;=====Endurance abilities=====
	PlayerRef.SetActorValue("StaminaRate", (4 + SwimAbility + SprintAbility))
	Game.SetGameSettingFloat("fSprintStaminaDrainMult", (8 - (SprintAbility + SwimAbility)))

;=====Jump abilities=====
	if JumpAbility >= 1.0 && SprintAbility >= 0.4 
		if SprintJumpAbility.GetValue() == 0
			NewAbilityMessage.Show()
		endif
		SprintJumpAbility.SetValue(1)
		if AthleticQuestSprintJump.isRunning() == 0
			AthleticQuestSprintJump.Start()
		endif
	else
		SprintJumpAbility.SetValue(0)
	endif
;	if JumpAbility > 1.0 && SprintJumpBoostAbility.GetValue() <= 1.0
;		NewAbilityMessage.Show()
;	endif
;	SprintJumpBoostAbility.SetValue(JumpAbility)

;=====Swim abilities=====
	if SwimAbility >= 0.2
		if ReducedDiveDamageAbility.GetValue() == 0
			NewAbilityMessage.Show()
		endif
		ReducedDiveDamageAbility.SetValue(1)
		Game.SetGameSettingFloat("fActorSwimBreathDamage", (0.08 * (1.1 - SwimAbility)))
	else
		ReducedDiveDamageAbility.SetValue(0)
		Game.SetGameSettingFloat("fActorSwimBreathDamage", 0.08)
	endif

;=====Sprint abilities=====
	if SprintAbility >= 0.8 
		if SprintPowerAbility.GetValue() == 0
			NewAbilityMessage.Show()
		endif
		SprintPowerAbility.SetValue(1)
	else
		SprintPowerAbility.SetValue(0)
	endif
	if SprintAbility >= 1.6
		if CatchbreathAbility.GetValue() == 0
			NewAbilityMessage.Show()
		endif
		CatchbreathAbility.SetValue(1)
		Game.SetGameSettingFloat("fOutOfBreathStaminaRegenDelay", 0)
	else
		CatchbreathAbility.SetValue(0)
 		Game.SetGameSettingFloat("fOutOfBreathStaminaRegenDelay", 3)
	endif
	if SprintAbility >= 2.0
		if SprintWaterAbility.GetValue() == 0
			NewAbilityMessage.Show()
		endif
		SprintWaterAbility.SetValue(1)
	else
		SprintWaterAbility.SetValue(0)
	endif
EndFunction

;=====Calculate Fatigue and set Power Sprint=====
Function CalculateFatigue()
	if PlayerRef.HasSpell(Rested) || PlayerRef.HasSpell(WellRested)
		if RestedCooldown <= 0.0
			Fatigue.SetValue(0)
			if SprintPowerAbility.GetValue() == 1
				SprintPowerAbility.SetValue(2)
				PowerSprintMessage.show()
			endif
			RestedCooldown = 8.0
		endif
	else
		Fatigue.SetValue(Fatigue.GetValue() + (FatigueRate.GetValue()*0.5))
	endif
	FatigueMod = Fatigue.GetValue()
EndFunction

;=====Get Body Weight=====
Function GetBodyWeight()
	if BodyToggle.GetValue() == 1
		ActorBase pActorBase = PlayerRef.GetActorBase()
		int ActorWeight = pActorBase.GetWeight() as int
		if ActorWeight < 50
			BodyMod = ((ActorWeight * 0.4) - 10)
		elseif ActorWeight > 50
			BodyMod = ((ActorWeight * -0.4) + 30)
		else
			BodyMod = 10.0
		endif
	else
		BodyMod = 0.0
	endif
;debug.notification(BodyMod)
EndFunction


;=====Get Player Race=====
Function GetPlayerRace()
	Race PlayerRace = PlayerRef.GetRace()
	int BonusSpeed
	int BonusJump
	int BaseSpeed = 85
	int BaseJump = 65

	if PlayerRace == pKhajiitRace
		BonusJump = KhajiitJumpBonus.GetValue() as int;25
		BonusSpeed = KhajiitSpeedBonus.GetValue() as int;20
	elseif PlayerRace == pNordRace
		BonusJump = NordJumpBonus.GetValue() as int; 5
		BonusSpeed = NordSpeedBonus.GetValue() as int; 10
	elseif PlayerRace == pArgonianRace
		BonusJump = ArgonianJumpBonus.GetValue() as int; 5
		BonusSpeed = ArgonianSpeedBonus.GetValue() as int; 25
	elseif PlayerRace == pBretonRace
		BonusJump = BretonJumpBonus.GetValue() as int; 0
		BonusSpeed = BretonSpeedBonus.GetValue() as int;5
	elseif PlayerRace == pImperialRace
		BonusJump = ImperialJumpBonus.GetValue() as int;5
		BonusSpeed = ImperialSpeedBonus.GetValue() as int;5
	elseif PlayerRace == pHighElfRace
		BonusJump = HighElfJumpBonus.GetValue() as int;0
		BonusSpeed = HighElfSpeedBonus.GetValue() as int;0
	elseif PlayerRace == pWoodElfRace
		BonusJump = WoodElfJumpBonus.GetValue() as int;10
		BonusSpeed = WoodElfSpeedBonus.GetValue() as int;10
	elseif PlayerRace == pDarkElfRace
		BonusJump = DarkElfJumpBonus.GetValue() as int;15
		BonusSpeed = DarkElfSpeedBonus.GetValue() as int;10
	elseif PlayerRace == pOrcRace
		BonusJump = OrcJumpBonus.GetValue() as int;10
		BonusSpeed = OrcSpeedBonus.GetValue() as int;15
	elseif PlayerRace == pRedguardRace
		BonusJump = RedguardJumpBonus.GetValue() as int;15
		BonusSpeed = RedguardSpeedBonus.GetValue() as int;15
	elseif PlayerRace == pWerewolfBeastRace
		BonusJump = WerewolfJumpBonus.GetValue() as int;50
		BonusSpeed = WerewolfSpeedBonus.GetValue() as int;20
	elseif PlayerRace == pKhajiitRaceVampire
		BonusJump = (KhajiitJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (KhajiitSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pNordRaceVampire
		BonusJump = (NordJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (NordSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pArgonianRaceVampire
		BonusJump = (ArgonianJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (ArgonianSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pBretonRaceVampire
		BonusJump = (BretonJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (BretonSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pImperialRaceVampire
		BonusJump = (ImperialJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (ImperialSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pHighElfRaceVampire
		BonusJump = (HighElfJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (HighElfSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pWoodElfRaceVampire
		BonusJump = (WoodElfJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (WoodElfSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pDarkElfRaceVampire
		BonusJump = (DarkElfJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (DarkElfSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pOrcRaceVampire
		BonusJump = (OrcJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (OrcSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRace == pRedguardRaceVampire
		BonusJump = (RedguardJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (RedguardSpeedBonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	elseif PlayerRef.IsInFaction(pVampirePCFaction)
		BonusJump = (CustomRaceJumpBonus.GetValue() + VampireJumpBonus.GetValue()) as int
		BonusSpeed = (CustomRaceSpeedbonus.GetValue() + VampireSpeedBonus.GetValue()) as int
	else;if !PlayerRef.IsInFaction(pVampirePCFaction)
		BonusJump = CustomRaceJumpBonus.GetValue() as int
		BonusSpeed = CustomRaceSpeedbonus.GetValue() as int
	endif
	
;====="Better Vampires" compatibility=====
	bool BetterVampires = Game.GetFormFromFile(0x0007A9CF, "Better Vampires.esp")
	bool BetterVampiresNDG = Game.GetFormFromFile(0x0007A9CF, "Better Vampires - No DawnGuard.esp")
	bool BetterVampiresML = Game.GetFormFromFile(0x0007A9CF, "Better Vampires ML.esp")
	bool BetterVampiresMLNDG = Game.GetFormFromFile(0x0007A9CF, "Better Vampires ML - No DawnGuard.esp")
	bool BV = 0
	GlobalVariable VampireJumpingBonus
	GlobalVariable VampireRank
	if BetterVampires
		VampireJumpingBonus = Game.GetFormFromFile(0x0007A9CF, "Better Vampires.esp") as GlobalVariable 
		VampireRank = Game.GetFormFromFile(0x0003713C, "Better Vampires.esp") as GlobalVariable 
		BV = 1
	elseif BetterVampiresNDG
		VampireJumpingBonus = Game.GetFormFromFile(0x0007A9CF, "Better Vampires - No DawnGuard.esp") as GlobalVariable 
		VampireRank = Game.GetFormFromFile(0x0003713C, "Better Vampires - No DawnGuard.esp") as GlobalVariable 
		BV = 1
	elseif BetterVampiresML
		VampireJumpingBonus = Game.GetFormFromFile(0x0007A9CF, "Better Vampires ML.esp") as GlobalVariable 
		VampireRank = Game.GetFormFromFile(0x0003713C, "Better Vampires ML.esp") as GlobalVariable 
		BV = 1
	elseif BetterVampiresMLNDG
		VampireJumpingBonus = Game.GetFormFromFile(0x0007A9CF, "Better Vampires ML - No DawnGuard.esp") as GlobalVariable 
		VampireRank = Game.GetFormFromFile(0x0003713C, "Better Vampires ML - No DawnGuard.esp") as GlobalVariable 
		BV = 1
	endif
	if BV && VampireRaces.HasForm(PlayerRace) && VampireJumpingBonus.GetValue() == 0 
		if VampireRank.GetValue() < 20000
			BVJumpBonus.SetValue(0)
			BVSpeedBonus.SetValue(0)
			BonusJump += 0
			BonusSpeed += 0
		elseif	VampireRank.GetValue() == 20000
			BVJumpBonus.SetValue(25)
			BVSpeedBonus.SetValue(5)
			BonusJump += 25
			BonusSpeed += 5
		elseif	VampireRank.GetValue() == 30000
			BVJumpBonus.SetValue(50)
			BVSpeedBonus.SetValue(10)
			BonusJump += 50
			BonusSpeed += 10
		elseif	VampireRank.GetValue() == 40000
			BVJumpBonus.SetValue(80)
			BVSpeedBonus.SetValue(15)
			BonusJump += 80
			BonusSpeed += 15
		elseif	VampireRank.GetValue() == 50000
			BVJumpBonus.SetValue(110)
			BVSpeedBonus.SetValue(20)
			BonusJump += 110
			BonusSpeed += 20
		elseif	VampireRank.GetValue() >= 60000
			BVJumpBonus.SetValue(150)
			BVSpeedBonus.SetValue(25)
			BonusJump += 150
			BonusSpeed += 25
		endif
	endif

;=====Set Race modifiers=====	
	JumpRace = BaseJump + BonusJump
	SpeedRace = BaseSpeed + BonusSpeed
	GlobalJumpBonus.SetValue(BonusJump)
	GlobalSpeedBonus.SetValue(BonusSpeed)
	;debug.messagebox("Rank: " + VampireRank.GetValue() + ", SpeedRace: " + SpeedRace + ", BaseSpeed: " + BaseSpeed + ", BonusSpeed: " + BonusSpeed + ", JumpRace: " + JumpRace + ", BaseJump: " + BaseJump + ", BonusJump: " + BonusJump)
EndFunction

