Scriptname vvvAthleticMCM extends SKI_ConfigBase

GlobalVariable Property Version  Auto
GlobalVariable Property AthleticInit  Auto
GlobalVariable Property CalcRate  Auto
GlobalVariable Property PauseCalc  Auto
GlobalVariable Property BodyToggle  Auto
GlobalVariable Property JumpTraining  Auto
GlobalVariable Property SprintTraining  Auto
GlobalVariable Property SwimTraining  Auto
GlobalVariable Property Fatigue  Auto
GlobalVariable Property FatigueRate  Auto
GlobalVariable Property TrainingMult  Auto
GlobalVariable Property StaminaMult  Auto
GlobalVariable Property InventoryMult  Auto
GlobalVariable Property CheatMult  Auto
GlobalVariable Property SprintJumpAbility  Auto
GlobalVariable Property SprintJumpBoostAbility  Auto
GlobalVariable Property CatchbreathAbility  Auto
GlobalVariable Property ReducedDiveDamageAbility  Auto
GlobalVariable Property SprintWaterAbility  Auto
GlobalVariable Property SprintPowerAbility  Auto
GlobalVariable Property JumpHeightValue  Auto
GlobalVariable Property SpeedValue  Auto
GlobalVariable Property GlobalJumpBonus  Auto
GlobalVariable Property GlobalSpeedBonus  Auto
GlobalVariable Property BVJumpBonus  Auto
GlobalVariable Property BVSpeedBonus  Auto
GlobalVariable Property MaxJump  Auto
GlobalVariable Property MaxSpeed  Auto
GlobalVariable Property MaxStamina  Auto
GlobalVariable Property JumpRankRate  Auto
GlobalVariable Property SprintRankRate  Auto
GlobalVariable Property SwimRankRate  Auto
GlobalVariable Property JumpRank  Auto
GlobalVariable Property SprintRank  Auto
GlobalVariable Property SwimRank  Auto

Actor Property PlayerRef  Auto
ReferenceAlias Property Player  Auto
Quest Property AthleticQuest  Auto
Quest Property AthleticQuestSprintJump  Auto
MiscObject Property SpeedToken  Auto  
Spell Property Rested Auto
Spell Property WellRested Auto
FormList Property VampireRaces  Auto
Bool Uninstalled

GlobalVariable Property KhajiitJumpBonus  Auto
GlobalVariable Property NordJumpBonus  Auto
GlobalVariable Property BretonJumpBonus  Auto
GlobalVariable Property OrcJumpBonus  Auto
GlobalVariable Property ArgonianJumpBonus  Auto
GlobalVariable Property DarkElfJumpBonus  Auto
GlobalVariable Property HighElfJumpBonus  Auto
GlobalVariable Property WoodElfJumpBonus  Auto
GlobalVariable Property RedguardJumpBonus  Auto
GlobalVariable Property ImperialJumpBonus  Auto
GlobalVariable Property WerewolfJumpBonus  Auto
GlobalVariable Property CustomRaceJumpBonus  Auto
GlobalVariable Property VampireJumpBonus  Auto
GlobalVariable Property KhajiitSpeedBonus  Auto
GlobalVariable Property NordSpeedBonus  Auto
GlobalVariable Property BretonSpeedBonus  Auto
GlobalVariable Property OrcSpeedBonus  Auto
GlobalVariable Property ArgonianSpeedBonus  Auto
GlobalVariable Property DarkElfSpeedBonus  Auto
GlobalVariable Property HighElfSpeedBonus  Auto
GlobalVariable Property WoodElfSpeedBonus  Auto
GlobalVariable Property RedguardSpeedBonus  Auto
GlobalVariable Property ImperialSpeedBonus  Auto
GlobalVariable Property WerewolfSpeedBonus  Auto
GlobalVariable Property CustomRaceSpeedBonus  Auto
GlobalVariable Property VampireSpeedBonus  Auto

;Training stats
int VersionString
int JumpCount
int SprintTime
int SwimTime
int JumpHeight
int Speed
int FallHeight

;Basic stats
int Stamina
int StaminaRRate
int StaminaDRate
int BodyWeight
int FortifyCarry
int InventoryWeight
int Sleep

;Special abilities
int SprintAndJump
;int SprintAndJumpBoost1
;int SprintAndJumpBoost2
int InstaCatchBreath
int ReducedDiveDamage
int WaterSprint
int PowerSprint

;Ranks
int NoobJump
int NoviceJump
int ApprenticeJump
int AdeptJump
int ExpertJump
int MasterJump
int NoobSprint
int NoviceSprint
int ApprenticeSprint
int AdeptSprint
int ExpertSprint
int MasterSprint
int NoobSwim
int NoviceSwim
int ApprenticeSwim
int AdeptSwim
int ExpertSwim
int MasterSwim
;int NoobStamina
;int NoviceStamina
;int ApprenticeStamina
;int AdeptStamina
;int ExpertStamina
;int MasterStamina
int NoobVampire
int NoviceVampire
int ApprenticeVampire
int AdeptVampire
int ExpertVampire
int MasterVampire
int BVJump
int BVSpeed
int JumpBonus
int SpeedBonus
int CurrentRace

;Options
int CalcRateSlider
int FatigueRateSlider
int TrainingMultSlider
int StaminaMultSlider
int InventoryMultSlider
int BodyOption
int CheatMultSlider
int DebugOption
int CalcOption
int ResetValue
int AdjustJumpSlider
int AdjustSprintSlider
int AdjustSwimSlider
int DisableWaterwalk
int SetJumpSlider
int SetSpeedSlider
int MaxJumpSlider
int MaxSpeedSlider
int MaxStaminaSlider
int JumpRankRateSlider
int SprintRankRateSlider
int SwimRankRateSlider
int JumpBonusSliderArgonian
int JumpBonusSliderBreton
int JumpBonusSliderImperial
int JumpBonusSliderNord
int JumpBonusSliderKhajiit
int JumpBonusSliderRedguard
int JumpBonusSliderOrc
int JumpBonusSliderDarkelf
int JumpBonusSliderWoodelf
int JumpBonusSliderHighelf
int JumpBonusSliderVampire
int JumpBonusSliderOther
int JumpBonusSliderWerewolf
int SpeedBonusSliderArgonian
int SpeedBonusSliderBreton
int SpeedBonusSliderImperial
int SpeedBonusSliderNord
int SpeedBonusSliderKhajiit
int SpeedBonusSliderRedguard
int SpeedBonusSliderOrc
int SpeedBonusSliderDarkelf
int SpeedBonusSliderWoodelf
int SpeedBonusSliderHighelf
int SpeedBonusSliderVampire
int SpeedBonusSliderOther
int SpeedBonusSliderWerewolf
int RaceOption
int UninstallOption

;Toggle states
bool bDebug = false
bool bCalc = true
bool bBody = true
bool bRace = false

int AdjustJump
int AdjustSprint

bool bSprintJumpAbility
;bool bSprintJumpBoostAbility
bool bCatchbreathAbility
bool bReducedDiveDamageAbility
bool bSprintWaterAbility
bool bSprintPowerAbility

;=======Menu Init=======
Event OnConfigOpen()
	if Player.GetReference() == None && !Uninstalled
		showmessage("$VAT_ALIAS_ERROR", false)
		AthleticQuest.Stop()
		AthleticInit.SetValue(0)
		AthleticQuest.Start()
		Player.ForceRefTo(Game.GetPlayer())
	elseif Uninstalled
		showmessage("$VAT_MSG_UNINSTALL_DONE", false)
	endif
	if PauseCalc.GetValue() == 1
		bCalc = false
	elseif PauseCalc.GetValue() == 0
		bCalc = true
	endif
	if BodyToggle.GetValue() == 0
		bBody = false
	elseif BodyToggle.GetValue() == 1
		bBody = true
	endif

;=======New ability messages=======
	if bSprintJumpAbility == false && SprintJumpAbility.GetValue() != 0.0
		showmessage("$VAT_MSG_ABILITY_SSJ", false)
		bSprintJumpAbility = true
	endif
;	if bSprintJumpBoostAbility == false && SprintJumpBoostAbility.GetValue() > 1.0
;		showmessage("$VAT_MSG_ABILITY_SJB", false)
;		bSprintJumpBoostAbility = true
;	endif
	if bCatchbreathAbility == false && CatchbreathAbility.GetValue() != 0.0
		showmessage("$VAT_MSG_ABILITY_CB", false)
		bCatchbreathAbility = true
	endif
	if bReducedDiveDamageAbility == false && ReducedDiveDamageAbility.GetValue() != 0.0
		showmessage("$VAT_MSG_ABILITY_RLD", false)
		bReducedDiveDamageAbility = true
	endif
	if bSprintWaterAbility == false && SprintWaterAbility.GetValue() != 0.0
		showmessage("$VAT_MSG_ABILITY_WS", false)
		bSprintWaterAbility = true
	endif
	if bSprintPowerAbility == false && SprintPowerAbility.GetValue() != 0.0
		showmessage("$VAT_MSG_ABILITY_PS", false)
		bSprintPowerAbility = true
	endif
EndEvent

;=======Menu Definition=======
Event OnPageReset(string page)
	Race PlayerRace = PlayerRef.GetRace()
	string ver = StringUtil.Substring(Version.GetValue() as string, 0, 4)

;=======Splash screen=======
	if page == ""
		LoadCustomContent("vvvAthletics/logo.dds", 248, 96)
		return
	else
		UnloadCustomContent()
	endif

if !uninstalled
;=======Skill Page=======
	if page == "$VAT_PAGE_SKILLSABILITIES"
		SetCursorFillMode(TOP_TO_BOTTOM)	
		SetCursorPosition(0)
		AddHeaderOption("$VAT_HEADER_SKILLS")

;=======Athletic Ranks=======
		float JR = JumpRank.GetValue()
		float SpR = SprintRank.GetValue()
		float SwR = SwimRank.GetValue()
		if JR < 1.0
			NoobJump = AddTextOption("$VAT_RANK_UNTRAINED_JUMPING", "")
		elseif JR == 1.0
			NoviceJump = AddTextOption("$VAT_RANK_NOVICE_JUMPING", "")
		elseif JR == 1.25
			ApprenticeJump = AddTextOption("$VAT_RANK_APPRENTICE_JUMPING", "")
		elseif JR == 1.5
			AdeptJump = AddTextOption("$VAT_RANK_ADEPT_JUMPING", "")
		elseif JR == 1.75
			ExpertJump = AddTextOption("$VAT_RANK_EXPERT_JUMPING", "")
		elseif JR >= 2.0
			MasterJump = AddTextOption("$VAT_RANK_MASTER_JUMPING", "")
		endif
		if SpR < 0.4
			NoobSprint = AddTextOption("$VAT_RANK_UNTRAINED_SPRINTING", "")
		elseif SpR == 0.4
			NoviceSprint = AddTextOption("$VAT_RANK_NOVICE_SPRINTING", "")
		elseif SpR == 0.8
			ApprenticeSprint = AddTextOption("$VAT_RANK_APPRENTICE_SPRINTING", "")
		elseif SpR == 1.2
			AdeptSprint = AddTextOption("$VAT_RANK_ADEPT_SPRINTING", "")
		elseif SpR == 1.6
			ExpertSprint = AddTextOption("$VAT_RANK_EXPERT_SPRINTING", "")
		elseif SpR >= 2.0
			MasterSprint = AddTextOption("$VAT_RANK_MASTER_SPRINTING", "")
		endif
		if SwR < 0.2
			NoobSwim = AddTextOption("$VAT_RANK_UNTRAINED_SWIMMING", "")
		elseif SwR == 0.2
			NoviceSwim = AddTextOption("$VAT_RANK_NOVICE_SWIMMING", "")
		elseif SwR == 0.4
			ApprenticeSwim = AddTextOption("$VAT_RANK_APPRENTICE_SWIMMING", "")
		elseif SwR == 0.6
			AdeptSwim = AddTextOption("$VAT_RANK_ADEPT_SWIMMING", "")
		elseif SwR == 0.8
			ExpertSwim = AddTextOption("$VAT_RANK_EXPERT_SWIMMING", "")
		elseif SwR >= 1.0
			MasterSwim = AddTextOption("$VAT_RANK_MASTER_SWIMMING", "")
		endif
;		float StaminaDrain = Game.GetGameSettingFloat("fSprintStaminaDrainMult")
;		if StaminaDrain >= 8.0
;			NoobStamina = AddTextOption("$VAT_RANK_UNTRAINED_ENDURANCE", "")
;		elseif StaminaDrain < 8.0 && StaminaDrain >= 7.25
;			NoviceStamina = AddTextOption("$VAT_RANK_NOVICE_ENDURANCE", "")
;		elseif StaminaDrain < 7.25 && StaminaDrain >= 6.5
;			ApprenticeStamina = AddTextOption("$VAT_RANK_APPRENTICE_ENDURANCE", "")
;		elseif StaminaDrain < 6.5 && StaminaDrain > 5.75
;			AdeptStamina = AddTextOption("$VAT_RANK_ADEPT_ENDURANCE", "")
;		elseif StaminaDrain < 5.75 && StaminaDrain > 5.0
;			ExpertStamina = AddTextOption("$VAT_RANK_EXPERT_ENDURANCE", "")
;		elseif StaminaDrain < 5.0
;			MasterStamina = AddTextOption("$VAT_RANK_MASTER_ENDURANCE", "")
;		endif

;=======Abilities=======
		AddHeaderOption("$VAT_HEADER_ABILITIES")
		int SprintJumpFlags = OPTION_FLAG_DISABLED
;		int JumpBoostFlags = OPTION_FLAG_DISABLED
		int WaterSprintFlags = OPTION_FLAG_DISABLED
		int PowerSprintFlags = OPTION_FLAG_DISABLED
		int InstaCatchBreathFlags = OPTION_FLAG_DISABLED
		int ReducedDiveDamageFlags = OPTION_FLAG_DISABLED

		if SprintJumpAbility.GetValue() == 1
			SprintJumpFlags = OPTION_FLAG_NONE
		endif
		SprintAndJump = AddTextOption("$VAT_ABILITY_SSJ", "", SprintJumpFlags)
		
;		if SprintJumpBoostAbility.GetValue() > 1.0
;			JumpBoostFlags = OPTION_FLAG_NONE
;		endif
;		SprintAndJumpBoost1 = AddTextOption("$VAT_ABILITY_SJB", "", JumpBoostFlags)

		if ReducedDiveDamageAbility.GetValue() == 1
			ReducedDiveDamageFlags = OPTION_FLAG_NONE
		endif
		ReducedDiveDamage = AddTextOption("$VAT_ABILITY_RLD", "", ReducedDiveDamageFlags)

		if CatchbreathAbility.GetValue() == 1
			InstaCatchBreathFlags = OPTION_FLAG_NONE
		endif
		InstaCatchBreath = AddTextOption("$VAT_ABILITY_CB", "", InstaCatchBreathFlags)

		if SprintWaterAbility.GetValue() == 1
			WaterSprintFlags = OPTION_FLAG_NONE
		endif
		WaterSprint = AddTextOption("$VAT_ABILITY_WS", "", WaterSprintFlags)

		string PowerSprintReady
		if SprintPowerAbility.GetValue() == 1
			PowerSprintFlags = OPTION_FLAG_NONE
			PowerSprintReady = ""
		elseif SprintPowerAbility.GetValue() == 2
			PowerSprintFlags = OPTION_FLAG_NONE
			PowerSprintReady = "$VAT_ABILITY_PS_READY"
		endif
		PowerSprint = AddTextOption("$VAT_ABILITY_PS", PowerSprintReady, PowerSprintFlags)

;=====Race Boni=====
		SetCursorPosition(1)
		AddHeaderOption("$VAT_HEADER_RACEBONI")
		if VampireRaces.HasForm(PlayerRace)
			CurrentRace = AddTextOption("$VAT_STAT_RACE_CURRENT_VAMPIRE", PlayerRace.GetName())
		else
			CurrentRace = AddTextOption("$VAT_STAT_RACE_CURRENT", PlayerRace.GetName())
		endif
		JumpBonus = AddTextOption("$VAT_STAT_RACE_JUMPBONUS", GlobalJumpBonus.Getvalue() as int)
		SpeedBonus = AddTextOption("$VAT_STAT_RACE_SPEEDBONUS", GlobalSpeedBonus.Getvalue() as int)

;=====Better Vampires Ranks=====
		bool BetterVampires = Game.GetFormFromFile(0x0007A9CF, "Better Vampires.esp")
		bool BetterVampiresNDG = Game.GetFormFromFile(0x0007A9CF, "Better Vampires - No DawnGuard.esp")
		bool BetterVampiresML = Game.GetFormFromFile(0x0007A9CF, "Better Vampires ML.esp")
		bool BetterVampiresMLNDG = Game.GetFormFromFile(0x0007A9CF, "Better Vampires ML - No DawnGuard.esp")
		bool BV = 0
		GlobalVariable VampireJumpingBonus
		GlobalVariable VampireRank
		if BetterVampires
			VampireJumpingBonus = Game.GetFormFromFile(0x0007A9CF, "Better Vampires.esp") as GlobalVariable 
			VampireRank = Game.GetFormFromFile(0x0003713C, "Better Vampires.esp") as GlobalVariable 
			BV = 1
		endif
		if BetterVampiresNDG
			VampireJumpingBonus = Game.GetFormFromFile(0x0007A9CF, "Better Vampires - No DawnGuard.esp") as GlobalVariable 
			VampireRank = Game.GetFormFromFile(0x0003713C, "Better Vampires - No DawnGuard.esp") as GlobalVariable 
			BV = 1
		endif
		if BetterVampiresML
			VampireJumpingBonus = Game.GetFormFromFile(0x0007A9CF, "Better Vampires ML.esp") as GlobalVariable 
			VampireRank = Game.GetFormFromFile(0x0003713C, "Better Vampires ML.esp") as GlobalVariable 
			BV = 1
		endif
		if BetterVampiresMLNDG
			VampireJumpingBonus = Game.GetFormFromFile(0x0007A9CF, "Better Vampires ML - No DawnGuard.esp") as GlobalVariable 
			VampireRank = Game.GetFormFromFile(0x0003713C, "Better Vampires ML - No DawnGuard.esp") as GlobalVariable 
			BV = 1
		endif
		if BV && VampireRaces.HasForm(PlayerRace) && VampireJumpingBonus.GetValue() == 0 
			AddHeaderOption("$VAT_HEADER_VAMPIRE")
			if VampireRank.GetValue() < 20000
				NoobVampire = AddTextOption("$VAT_RANK_UNTRAINED_VAMPIRE", "")
			elseif VampireRank.GetValue() == 20000
				NoviceVampire = AddTextOption("$VAT_RANK_NOVICE_VAMPIRE", "")
			elseif VampireRank.GetValue() == 30000
				ApprenticeVampire = AddTextOption("$VAT_RANK_APPRENTICE_VAMPIRE", "")
			elseif VampireRank.GetValue() == 40000
				AdeptVampire = AddTextOption("$VAT_RANK_ADEPT_VAMPIRE", "")
			elseif VampireRank.GetValue() == 50000
				ExpertVampire = AddTextOption("$VAT_RANK_EXPERT_VAMPIRE", "")
			elseif VampireRank.GetValue() >= 60000
				MasterVampire = AddTextOption("$VAT_RANK_MASTER_VAMPIRE", "")
			endif
			BVJump = AddTextOption("$VAT_RANK_VAMPIRE_JUMPBONUS", BVJumpBonus.Getvalue() as int)
			BVSpeed = AddTextOption("$VAT_RANK_VAMPIRE_SPEEDBONUS", BVSpeedBonus.Getvalue() as int)
		endif
		SetCursorPosition(23)
		VersionString = AddTextOption("$VAT_MOD_VERSION", ver)

;=======Statistics Page=======
	elseif page == "$VAT_PAGE_STATISTICS"
		SetCursorFillMode(TOP_TO_BOTTOM)	
		SetCursorPosition(0)
		AddHeaderOption("$VAT_HEADER_ATHLETICSTATS")
		Speed = AddTextOption("$VAT_STAT_SPEED", PlayerRef.GetActorValue("Speedmult") as int)
		JumpHeight = AddTextOption("$VAT_STAT_JUMPHEIGHT", Game.GetGameSettingFloat("fJumpHeightMin") as int)
		FallHeight = AddTextOption("$VAT_STAT_FALLHEIGHT", Game.GetGameSettingFloat("fJumpFallHeightMin") as int)
;		int SprintJumpBoostFlags
;		string sjb
;		if SprintJumpBoostAbility.GetValue() > 1.0
;			sjb = StringUtil.Substring(SprintJumpBoostAbility.GetValue() as string, 0, 4)
;			SprintJumpBoostFlags = OPTION_FLAG_NONE
;		else
;			sjb = ""
;			SprintJumpBoostFlags = OPTION_FLAG_DISABLED
;		endif
;		SprintAndJumpBoost2 = AddTextOption("$VAT_STAT_SPRINTJUMBOOST", sjb, SprintJumpBoostFlags)

		AddHeaderOption("$VAT_HEADER_TRAININGSTATS")
		int SwimTimeFlags = OPTION_FLAG_NONE
		int SprintTimeFlags = OPTION_FLAG_NONE
		int JumpCountFlags = OPTION_FLAG_NONE
		if TrainingMult.GetValue() == 0.0
			SwimTimeFlags = OPTION_FLAG_DISABLED
			SprintTimeFlags = OPTION_FLAG_DISABLED
			JumpCountFlags = OPTION_FLAG_DISABLED
		endif
		JumpCount = AddTextOption("$VAT_STAT_JUMPS", JumpTraining.GetValue() as int, JumpCountFlags)
		SprintTime = AddTextOption("$VAT_STAT_SPRINTTIME", SprintTraining.GetValue() as int, SprintTimeFlags)
		SwimTime = AddTextOption("$VAT_STAT_SWIMTIME", SwimTraining.GetValue() as int, SwimTimeFlags)

		SetCursorPosition(1)
		AddHeaderOption("$VAT_HEADER_BASICSTATS")
		Stamina = AddTextOption("$VAT_STAT_STAMINA", PlayerRef.GetActorValue("Stamina") as int)
		string srr = StringUtil.Substring(PlayerRef.GetActorValue("StaminaRate") as string, 0, 3)
		StaminaRRate = AddTextOption("$VAT_STAT_STAMINAREGEN", srr)
		string sdr = StringUtil.Substring(Game.GetGameSettingFloat("fSprintStaminaDrainMult") as string, 0, 3)
		StaminaDRate = AddTextOption("$VAT_STAT_STAMINADRAIN", sdr)
		if FatigueRate.GetValue() != 0.0
			Sleep = AddTextOption("$VAT_STAT_FATIGUE", Fatigue.GetValue() as int)
		elseif FatigueRate.GetValue() == 0.0
			Fatigue.SetValue(0)
		endif
		if InventoryMult.GetValue() != 0.0
			InventoryWeight = AddTextOption("$VAT_STAT_INVENTORYWEIGHT", PlayerRef.GetActorValue("InventoryWeight") as int)
			FortifyCarry = AddTextOption("$VAT_STAT_FORTIFIEDSTRENGTH", (PlayerRef.GetActorValue("CarryWeight") - PlayerRef.GetBaseActorValue("CarryWeight")) as int)
		endif
		ActorBase pActorBase = PlayerRef.GetActorBase()
		if BodyToggle.GetValue() == 1
			BodyWeight = AddTextOption("$VAT_STAT_BODYWEIGHT", pActorBase.GetWeight() as int)
		endif
		SetCursorPosition(23)
		VersionString = AddTextOption("$VAT_MOD_VERSION", ver)

;=======Options Page=======		
	elseif page == "$VAT_PAGE_OPTIONS"
		SetCursorFillMode(TOP_TO_BOTTOM)	
		SetCursorPosition(0)
		AddHeaderOption("$VAT_HEADER_OPTIONS")
		CalcRateSlider = AddSliderOption("$VAT_OPTION_CALCRATE", CalcRate.GetValue(), "{1}")
		TrainingMultSlider = AddSliderOption("$VAT_OPTION_TRAININGMULT", TrainingMult.GetValue(), "{1}")
		StaminaMultSlider = AddSliderOption("$VAT_OPTION_STAMINAMULT", StaminaMult.GetValue(), "{2}")
		FatigueRateSlider = AddSliderOption("$VAT_OPTION_FATIGUEAMOUNT", FatigueRate.GetValue(), "{1}")
		InventoryMultSlider = AddSliderOption("$VAT_OPTION_INVENTORYMULT", InventoryMult.GetValue(), "{2}")
		BodyOption = AddToggleOption("$VAT_OPTION_BODYWEIGHT",  bBody)
		MaxSpeedSlider = AddSliderOption("$VAT_OPTION_MAXSPEED", MaxSpeed.GetValue() as int, "{0}")
		MaxJumpSlider = AddSliderOption("$VAT_OPTION_MAXJUMP", MaxJump.GetValue() as int, "{0}")
		MaxStaminaSlider = AddSliderOption("$VAT_OPTION_MAXSTAMINA", MaxStamina.GetValue() as int, "{0}")
		JumpRankRateSlider = AddSliderOption("$VAT_OPTION_JUMPRANKRATE", JumpRankRate.GetValue(), "{2}")
		SprintRankRateSlider = AddSliderOption("$VAT_OPTION_SPRINTRANKRATE", SprintRankRate.GetValue(), "{2}")
		SwimRankRateSlider = AddSliderOption("$VAT_OPTION_SWIMRANKRATE", SwimRankRate.GetValue(), "{2}")
		
		SetCursorPosition(1)
		AddHeaderOption("$VAT_HEADER_DEBUG")
		DebugOption = AddToggleOption("$VAT_OPTION_SHOWDEBUG",  bDebug)
		if bDebug == true
			CheatMultSlider = AddSliderOption("$VAT_OPTION_GLOBALMULT", CheatMult.GetValue(), "{1}")
			AdjustJumpSlider = AddSliderOption("$VAT_OPTION_ADJUSTJUMP", JumpTraining.GetValue())
			AdjustSprintSlider = AddSliderOption("$VAT_OPTION_ADJUSTSPRINT", SprintTraining.GetValue())
			AdjustSwimSlider = AddSliderOption("$VAT_OPTION_ADJUSTSWIM", SwimTraining.GetValue())
			CalcOption = AddToggleOption("$VAT_OPTION_TOGGLECALC", bCalc)
			;int ResetValueFlags = OPTION_FLAG_DISABLED
			int SetSpeedSliderFlags = OPTION_FLAG_DISABLED
			int SetJumpSliderFlags = OPTION_FLAG_DISABLED
			if bCalc == false
				;ResetValueFlags = OPTION_FLAG_NONE
				SetSpeedSliderFlags = OPTION_FLAG_NONE
				SetJumpSliderFlags = OPTION_FLAG_NONE
			endif
			;ResetValue = AddTextOption("$VAT_OPTION_RESETSTATS", "", ResetValueFlags)
			SetSpeedSlider = AddSliderOption("$VAT_OPTION_SETSPEED", PlayerRef.GetActorValue("Speedmult") as int, "{0}", SetSpeedSliderFlags)
			SetJumpSlider = AddSliderOption("$VAT_OPTION_SETJUMP", Game.GetGameSettingFloat("fJumpHeightMin") as int, "{0}", SetJumpSliderFlags)
		endif
		if PlayerRef.GetActorValue("WaterWalking") == 1
			DisableWaterwalk = AddTextOption("$VAT_OPTION_DISABLEWATERWALK", "")
		endif
		UninstallOption = AddTextOption("$VAT_OPTION_UNINSTALL", "")
		SetCursorPosition(26)
		AddHeaderOption("$VAT_HEADER_JUMPBONI")
		int RaceOptionsFlags = OPTION_FLAG_DISABLED
		if bRace
			RaceOptionsFlags = OPTION_FLAG_NONE
		endif
		JumpBonusSliderArgonian = AddSliderOption("$VAT_OPTION_BONUSARGONIAN", ArgonianJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderBreton = AddSliderOption("$VAT_OPTION_BONUSBRETON", BretonJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderDarkelf = AddSliderOption("$VAT_OPTION_BONUSDARKELF", DarkelfJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderHighelf = AddSliderOption("$VAT_OPTION_BONUSHIGHELF", HighelfJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderImperial = AddSliderOption("$VAT_OPTION_BONUSIMPERIAL", ImperialJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderKhajiit = AddSliderOption("$VAT_OPTION_BONUSKHAJIIT", KhajiitJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderNord = AddSliderOption("$VAT_OPTION_BONUSNORD", NordJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderOrc = AddSliderOption("$VAT_OPTION_BONUSORC", OrcJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderRedGuard = AddSliderOption("$VAT_OPTION_BONUSREDGUARD", RedguardJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderWoodelf = AddSliderOption("$VAT_OPTION_BONUSWOODELF", WoodelfJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderOther = AddSliderOption("$VAT_OPTION_BONUSOTHER", CustomRaceJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderWerewolf = AddSliderOption("$VAT_OPTION_BONUSWEREWOLF", WerewolfJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		JumpBonusSliderVampire = AddSliderOption("$VAT_OPTION_BONUSVAMPIRE", VampireJumpBonus.GetValue(), "{0}", RaceOptionsFlags)
		AddEmptyOption()
		RaceOption = AddToggleOption("$VAT_OPTION_ENABLERACEOPTIONS",  bRace)
		SetCursorPosition(27)
		AddHeaderOption("$VAT_HEADER_SPEEDBONI")
		SpeedBonusSliderArgonian = AddSliderOption("$VAT_OPTION_BONUSARGONIAN", ArgonianSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderBreton = AddSliderOption("$VAT_OPTION_BONUSBRETON", BretonSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderDarkelf = AddSliderOption("$VAT_OPTION_BONUSDARKELF", DarkelfSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderHighelf = AddSliderOption("$VAT_OPTION_BONUSHIGHELF", HighelfSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderImperial = AddSliderOption("$VAT_OPTION_BONUSIMPERIAL", ImperialSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderKhajiit = AddSliderOption("$VAT_OPTION_BONUSKHAJIIT", KhajiitSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderNord = AddSliderOption("$VAT_OPTION_BONUSNORD", NordSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderOrc = AddSliderOption("$VAT_OPTION_BONUSORC", OrcSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderRedGuard = AddSliderOption("$VAT_OPTION_BONUSREDGUARD", RedguardSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderWoodelf = AddSliderOption("$VAT_OPTION_BONUSWOODELF", WoodelfSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderOther = AddSliderOption("$VAT_OPTION_BONUSOTHER", CustomRaceSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderWerewolf = AddSliderOption("$VAT_OPTION_BONUSWEREWOLF", WerewolfSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		SpeedBonusSliderVampire = AddSliderOption("$VAT_OPTION_BONUSVAMPIRE", VampireSpeedBonus.GetValue(), "{0}", RaceOptionsFlags)
		AddEmptyOption()
		VersionString = AddTextOption("$VAT_MOD_VERSION", ver)
	endif
endif
EndEvent

;=======Slider Options=======
Event OnOptionSliderOpen(int option)
	if (option == InventoryMultSlider)
		SetSliderDialogStartValue(InventoryMult.GetValue())
		SetSliderDialogDefaultValue(0.10)
		SetSliderDialogRange(0.0, 1.0)
		SetSliderDialogInterval(0.01)
	elseif (option == TrainingMultSlider)
		SetSliderDialogStartValue(TrainingMult.GetValue())
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 2.0)
		SetSliderDialogInterval(0.1)
	elseif (option == StaminaMultSlider)
		SetSliderDialogStartValue(StaminaMult.GetValue())
		SetSliderDialogDefaultValue(0.15)
		SetSliderDialogRange(0.0, 0.3)
		SetSliderDialogInterval(0.01)
	elseif (option == CalcRateSlider)
		SetSliderDialogStartValue(CalcRate.GetValue())
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(0.5, 5.0)
		SetSliderDialogInterval(0.1)
	elseif (option == FatigueRateSlider)
		SetSliderDialogStartValue(FatigueRate.GetValue())
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 2.0)
		SetSliderDialogInterval(0.1)
	elseif (option == CheatMultSlider)
		SetSliderDialogStartValue(CheatMult.GetValue())
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(0.2)
	elseif (option == AdjustJumpSlider)
		SetSliderDialogStartValue(JumpTraining.GetValue())
		SetSliderDialogDefaultValue(JumpTraining.GetValue())
		SetSliderDialogRange(0, (JumpRankRate.GetValue()*10000))
		SetSliderDialogInterval(10.0)
	elseif (option == AdjustSprintSlider)
		SetSliderDialogStartValue(SprintTraining.GetValue())
		SetSliderDialogDefaultValue(SprintTraining.GetValue())
		SetSliderDialogRange(0, (SprintRankRate.GetValue()*10000))
		SetSliderDialogInterval(10.0)
	elseif (option == AdjustSwimSlider)
		SetSliderDialogStartValue(SwimTraining.GetValue())
		SetSliderDialogDefaultValue(SwimTraining.GetValue())
		SetSliderDialogRange(0, (SwimRankRate.GetValue()*10000))
		SetSliderDialogInterval(10.0)
	elseif (option == SetJumpSlider)
		SetSliderDialogStartValue(Game.GetGameSettingFloat("fJumpHeightMin") as int)
		SetSliderDialogDefaultValue(76)
		SetSliderDialogRange(0, MaxJump.GetValue())
		SetSliderDialogInterval(1.0)
	elseif (option == SetSpeedSlider)
		SetSliderDialogStartValue(PlayerRef.GetActorValue("Speedmult") as int)
		SetSliderDialogDefaultValue(100)
		SetSliderDialogRange(0, MaxSpeed.GetValue())
		SetSliderDialogInterval(1.0)
	elseif (option == MaxJumpSlider)
		SetSliderDialogStartValue(MaxJump.GetValue() as int)
		SetSliderDialogDefaultValue(350)
		SetSliderDialogRange(0, 500)
		SetSliderDialogInterval(1.0)
	elseif (option == MaxSpeedSlider)
		SetSliderDialogStartValue(MaxSpeed.GetValue() as int)
		SetSliderDialogDefaultValue(500)
		SetSliderDialogRange(0, 1000)
		SetSliderDialogInterval(1.0)
	elseif (option == MaxStaminaSlider)
		SetSliderDialogStartValue(MaxStamina.GetValue() as int)
		SetSliderDialogDefaultValue(1000)
		SetSliderDialogRange(100, 2000)
		SetSliderDialogInterval(50.0)
	elseif (option == JumpRankRateSlider)
		SetSliderDialogStartValue(JumpRankRate.GetValue())
		SetSliderDialogDefaultValue(1)
		SetSliderDialogRange(0.25, 3)
		SetSliderDialogInterval(0.25)
	elseif (option == SprintRankRateSlider)
		SetSliderDialogStartValue(SprintRankRate.GetValue())
		SetSliderDialogDefaultValue(1)
		SetSliderDialogRange(0.25, 3)
		SetSliderDialogInterval(0.25)
	elseif (option == SwimRankRateSlider)
		SetSliderDialogStartValue(SwimRankRate.GetValue())
		SetSliderDialogDefaultValue(1)
		SetSliderDialogRange(0.25, 3)
		SetSliderDialogInterval(0.25)
;=======Race Slider Options=======
	elseif (option == JumpBonusSliderArgonian)
		SetSliderDialogStartValue(ArgonianJumpBonus.GetValue())
		SetSliderDialogDefaultValue(5)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderBreton)
		SetSliderDialogStartValue(BretonJumpBonus.GetValue())
		SetSliderDialogDefaultValue(0)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderDarkelf)
		SetSliderDialogStartValue(DarkelfJumpBonus.GetValue())
		SetSliderDialogDefaultValue(15)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderHighelf)
		SetSliderDialogStartValue(HighelfJumpBonus.GetValue())
		SetSliderDialogDefaultValue(0)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderImperial)
		SetSliderDialogStartValue(ImperialJumpBonus.GetValue())
		SetSliderDialogDefaultValue(5)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderKhajiit)
		SetSliderDialogStartValue(KhajiitJumpBonus.GetValue())
		SetSliderDialogDefaultValue(25)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderNord)
		SetSliderDialogStartValue(NordJumpBonus.GetValue())
		SetSliderDialogDefaultValue(5)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderOrc)
		SetSliderDialogStartValue(OrcJumpBonus.GetValue())
		SetSliderDialogDefaultValue(10)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderRedguard)
		SetSliderDialogStartValue(RedguardJumpBonus.GetValue())
		SetSliderDialogDefaultValue(15)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderWoodelf)
		SetSliderDialogStartValue(WoodelfJumpBonus.GetValue())
		SetSliderDialogDefaultValue(10)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderOther)
		SetSliderDialogStartValue(CustomRaceJumpBonus.GetValue())
		SetSliderDialogDefaultValue(5)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderWerewolf)
		SetSliderDialogStartValue(WerewolfJumpBonus.GetValue())
		SetSliderDialogDefaultValue(50)
		SetSliderDialogRange(0, 50)
		SetSliderDialogInterval(1)
	elseif (option == JumpBonusSliderVampire)
		SetSliderDialogStartValue(VampireJumpBonus.GetValue())
		SetSliderDialogDefaultValue(25)
		SetSliderDialogRange(0, 50)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderArgonian)
		SetSliderDialogStartValue(ArgonianSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(25)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderBreton)
		SetSliderDialogStartValue(BretonSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(5)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderDarkelf)
		SetSliderDialogStartValue(DarkelfSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(10)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderHighelf)
		SetSliderDialogStartValue(HighelfSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(0)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderImperial)
		SetSliderDialogStartValue(ImperialSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(5)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderKhajiit)
		SetSliderDialogStartValue(KhajiitSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(20)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderNord)
		SetSliderDialogStartValue(NordSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(10)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderOrc)
		SetSliderDialogStartValue(OrcSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(15)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderRedguard)
		SetSliderDialogStartValue(RedguardSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(15)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderWoodelf)
		SetSliderDialogStartValue(WoodelfSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(10)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderOther)
		SetSliderDialogStartValue(CustomRaceSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(5)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderWerewolf)
		SetSliderDialogStartValue(WerewolfSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(25)
		SetSliderDialogRange(0, 50)
		SetSliderDialogInterval(1)
	elseif (option == SpeedBonusSliderVampire)
		SetSliderDialogStartValue(VampireSpeedBonus.GetValue())
		SetSliderDialogDefaultValue(10)
		SetSliderDialogRange(0, 50)
		SetSliderDialogInterval(1)
	endif
EndEvent

Event OnOptionSliderAccept(int option, float value)
	if (option == InventoryMultSlider)
		InventoryMult.SetValue(value)
		SetSliderOptionValue(option, value, "{2}")
	elseif (option == TrainingMultSlider)
		TrainingMult.SetValue(value)
		SetSliderOptionValue(option, value, "{1}")
	elseif (option == StaminaMultSlider)
		StaminaMult.SetValue(value)
		SetSliderOptionValue(option, value, "{2}")
	elseif (option == CalcRateSlider)
		CalcRate.SetValue(value)
		SetSliderOptionValue(option, value, "{1}")
	elseif (option == FatigueRateSlider)
		FatigueRate.SetValue(value)
		SetSliderOptionValue(option, value, "{1}")
	elseif (option == CheatMultSlider)
		CheatMult.SetValue(value)
		SetSliderOptionValue(option, value, "{1}")
	elseif (option == AdjustJumpSlider)
		JumpTraining.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == AdjustSprintSlider)
		SprintTraining.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == AdjustSwimSlider)
		SwimTraining.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SetJumpSlider)
		Game.SetGameSettingFloat("fJumpHeightMin", value)
		JumpHeightValue.SetValue(value)
		if (value*7.895) >= 600
			Game.SetGameSettingFloat("fJumpFallHeightMin", (value*7.895) as int)
		else
			Game.SetGameSettingFloat("fJumpFallHeightMin", 600)
		endif
		SetSliderOptionValue(option, value)
	elseif (option == SetSpeedSlider)
		PlayerRef.SetActorValue("Speedmult", value)
		SpeedValue.SetValue(value)
		PlayerRef.AddItem(Speedtoken, 1, true) 
		PlayerRef.RemoveItem(Speedtoken, 1, true)
		SetSliderOptionValue(option, value)
	elseif (option == MaxStaminaSlider)
		MaxStamina.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == MaxJumpSlider)
		MaxJump.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == MaxSpeedSlider)
		if value > 0 && value < 50
			value = 50
		endif
		MaxSpeed.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpRankRateSlider)
		JumpRankRate.SetValue(value)
		SetSliderOptionValue(option, value, "{2}")
	elseif (option == SprintRankRateSlider)
		SprintRankRate.SetValue(value)
		SetSliderOptionValue(option, value, "{2}")
	elseif (option == SwimRankRateSlider)
		SwimRankRate.SetValue(value)
		SetSliderOptionValue(option, value, "{2}")
;=======Race Slider Options=======
	elseif (option == JumpBonusSliderArgonian)
		ArgonianJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderBreton)
		BretonJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderDarkelf)
		DarkelfJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderHighelf)
		HighelfJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderImperial)
		ImperialJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderKhajiit)
		KhajiitJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderNord)
		NordJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderOrc)
		OrcJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderRedguard)
		RedguardJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderWoodelf)
		WoodelfJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderOther)
		CustomRaceJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderWerewolf)
		WerewolfJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == JumpBonusSliderVampire)
		VampireJumpBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderArgonian)
		ArgonianSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderBreton)
		BretonSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderDarkelf)
		DarkelfSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderHighelf)
		HighelfSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderImperial)
		ImperialSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderKhajiit)
		KhajiitSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderNord)
		NordSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderOrc)
		OrcSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderRedguard)
		RedguardSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderWoodelf)
		WoodelfSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderOther)
		CustomRaceSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderWerewolf)
		WerewolfSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	elseif (option == SpeedBonusSliderVampire)
		VampireSpeedBonus.SetValue(value)
		SetSliderOptionValue(option, value)
	endif
	ForcePageReset()
EndEvent

;=======Toggle Options=======
Event OnOptionSelect(int option)
	if (option == BodyOption)
		if bBody ==  true
			if showmessage("$VAT_MSG_BODYWEIGHT_OFF")
				BodyToggle.SetValue(0)
				bBody = false
			endif
		elseif bBody == false
			if showmessage("$VAT_MSG_BODYWEIGHT_ON")
				BodyToggle.SetValue(1)
				bBody = true
			endif
		endif
		SetToggleOptionValue(BodyOption, bBody)
	elseif (option == DebugOption)
		bDebug = !bDebug
		SetToggleOptionValue(DebugOption, bDebug)
	elseif (option == CalcOption)
		if bCalc ==  true
			if showmessage("$VAT_MSG_TOGGLECALC_OFF")
				PauseCalc.SetValue(1)
				bCalc = !bCalc
				ResetStats()
			endif
		elseif bCalc == false
			if showmessage("$VAT_MSG_TOGGLECALC_ON")
				PauseCalc.SetValue(0)
				bCalc = !bCalc
			endif
		endif
		SetToggleOptionValue(DebugOption, bCalc)
;	elseif (option == ResetValue)
;		if showmessage("$VAT_MSG_RESETSTATS")
;			ResetStats()
;		endif
	elseif (option == DisableWaterWalk)
		if showmessage("$VAT_MSG_DISABLEWATERWALK")
			PlayerRef.SetActorValue("WaterWalking", 0)
		endif
	elseif (option == RaceOption)
		bRace = !bRace
		SetToggleOptionValue(RaceOption, bRace)
	elseif (option == UninstallOption)
		if showmessage("$VAT_MSG_UNINSTALL")
			AthleticQuest.Stop()
			AthleticQuestSprintJump.Stop()
			PauseCalc.SetValue(1)
			bCalc = false
			uninstalled = true
			ResetStats()
			Player.Clear()
			showmessage("$VAT_MSG_UNINSTALL_DONE", false)
		endif
	endif
	ForcePageReset()
EndEvent

;=======Reset stats to default=======
Function ResetStats()
	PlayerRef.SetActorValue("StaminaRate", 5)
	Game.SetGameSettingFloat("fSprintStaminaDrainMult", 7.0)
	Game.SetGameSettingFloat("fJumpFallHeightMin", 600.0)
	Game.SetGameSettingFloat("fJumpHeightMin", 76.0)
	PlayerRef.SetActorValue("Speedmult", 100)
	PlayerRef.AddItem(Speedtoken, 1, true) 
	PlayerRef.RemoveItem(Speedtoken, 1, true)
EndFunction

;=======Info Text=======
Event OnOptionHighlight(int option)
	string ver = StringUtil.Substring(Version.GetValue() as string, 0, 4)
	if (option == InventoryMultSlider)
		SetInfoText("$VAT_INFO_INVENTORYMULT")
	elseif (option == TrainingMultSlider)
		SetInfoText("$VAT_INFO_TRAININGMULT")
	elseif (option == StaminaMultSlider)
		SetInfoText("$VAT_INFO_STAMINAMULT")
	elseif (option == CalcRateSlider)
		SetInfoText("$VAT_INFO_CALCRATE")
	elseif (option == FatigueRateSlider)
		SetInfoText("$VAT_INFO_FATIGUEAMOUNT")
	elseif (option == BodyOption)
		SetInfoText("$VAT_INFO_TOGGLEBODYWEIGHT")
	elseif (option == CheatMultSlider)
		SetInfoText("$VAT_INFO_GLOBALMULT")
	elseif (option == DebugOption)
		SetInfoText("$VAT_INFO_SHOWDEBUG")
	elseif (option == CalcOption)
		SetInfoText("$VAT_INFO_TOGGLECALC")
	elseif (option == ResetValue)
		SetInfoText("$VAT_INFO_RESETSTATS")
	elseif (option == AdjustJumpSlider)
		SetInfoText("$VAT_INFO_ADJUSTJUMP")
	elseif (option == AdjustSprintSlider)
		SetInfoText("$VAT_INFO_ADJUSTSPRINT")
	elseif (option == AdjustSwimSlider)
		SetInfoText("$VAT_INFO_ADJUSTSWIM")
	elseif (option == JumpCount)
		SetInfoText("$VAT_INFO_JUMPCOUNT")
	elseif (option == SprintTime)
		SetInfoText("$VAT_INFO_SPRINTTIME")
	elseif (option == SwimTime)
		SetInfoText("$VAT_INFO_SWIMTIME")
	elseif (option == FallHeight)
		SetInfoText("$VAT_INFO_FALLHEIGHT")
	elseif (option == JumpHeight)
		SetInfoText("$VAT_INFO_JUMPHEIGHT")
	elseif (option == Speed)
		SetInfoText("$VAT_INFO_SPEED")
	elseif (option == Stamina)
		SetInfoText("$VAT_INFO_STAMINA")
	elseif (option == StaminaRRate)
		SetInfoText("$VAT_INFO_STAMINAREGEN")
	elseif (option == StaminaDRate)
		SetInfoText("$VAT_INFO_STAMINADRAIN")
	elseif (option == BodyWeight)
		SetInfoText("$VAT_INFO_BODYWEIGHT")
	elseif (option == InventoryWeight)
		SetInfoText("$VAT_INFO_INVENTORYWEIGHT")
	elseif (option == FortifyCarry)
		SetInfoText("$VAT_INFO_FORTIFYCARRY")
	elseif (option == Sleep)
		SetInfoText("$VAT_INFO_FATIGUE")
	elseif (option == NoobJump) || (option == NoviceJump) || (option == ApprenticeJump) || (option == AdeptJump) || (option == ExpertJump)
		SetInfoText("$VAT_INFO_RANK_JUMP")
	elseif (option == MasterJump)
		SetInfoText("$VAT_INFO_RANK_JUMPMASTER")
	elseif (option == NoobSprint) || (option == NoviceSprint) || (option == ApprenticeSprint) || (option == AdeptSprint) || (option == ExpertSprint)
		SetInfoText("$VAT_INFO_RANK_SPRINT")
	elseif (option == MasterSprint)
		SetInfoText("$VAT_INFO_RANK_SPRINTMASTER")
	elseif (option == NoobSwim) || (option == NoviceSwim) || (option == ApprenticeSwim) || (option == AdeptSwim) || (option == ExpertSwim)
		SetInfoText("$VAT_INFO_RANK_SWIM")
	elseif (option == MasterSwim)
		SetInfoText("$VAT_INFO_RANK_SWIMMASTER")
;	elseif (option == NoobStamina) || (option == NoviceStamina) || (option == ApprenticeStamina) || (option == AdeptStamina) || (option == ExpertStamina) || (option == MasterStamina)
;		SetInfoText("$VAT_INFO_RANK_ENDURANCE")
	elseif (option == SprintAndJump)
		SetInfoText("$VAT_INFO_ABILITY_SSJ")
;	elseif (option == SprintAndJumpBoost1)
;		SetInfoText("$VAT_INFO_ABILITY_SJB")
;	elseif (option == SprintAndJumpBoost2)
;		SetInfoText("$VAT_INFO_STAT_SJB")
	elseif (option == InstaCatchBreath)
		SetInfoText("$VAT_INFO_ABILITY_CB")
	elseif (option == ReducedDiveDamage)
		SetInfoText("$VAT_INFO_ABILITY_RLD")
	elseif (option == WaterSprint)
		SetInfoText("$VAT_INFO_ABILITY_WS")
	elseif (option == PowerSprint)
		SetInfoText("$VAT_INFO_ABILITY_PS")
	elseif (option == DisableWaterWalk)
		SetInfoText("$VAT_INFO_DISABLEWATERWALK")
	elseif (option == SetSpeedSlider)
		SetInfoText("$VAT_INFO_SETSPEED")
	elseif (option == SetJumpSlider)
		SetInfoText("$VAT_INFO_SETJUMP")
	elseif (option == MaxSpeedSlider)
		SetInfoText("$VAT_INFO_MAXSPEED")
	elseif (option == MaxJumpSlider)
		SetInfoText("$VAT_INFO_MAXJUMP")
	elseif (option == MaxStaminaSlider)
		SetInfoText("$VAT_INFO_MAXSTAMINA")
	elseif (option == CurrentRace)
		SetInfoText("$VAT_INFO_RACE_CURRENT")
	elseif (option == JumpBonus)
		SetInfoText("$VAT_INFO_RACE_JUMPBONUS")
	elseif (option == SpeedBonus)
		SetInfoText("$VAT_INFO_RACE_SPEEDBONUS")
	elseif (option == NoobVampire) || (option == NoviceVampire) || (option == ApprenticeVampire) || (option == AdeptVampire) || (option == ExpertVampire) || (option == MasterVampire)
		SetInfoText("$VAT_INFO_VAMPIRE_RANK")
	elseif (option == BVJump)
		SetInfoText("$VAT_INFO_VAMPIRE_JUMPBONUS")
	elseif (option == BVSpeed)
		SetInfoText("$VAT_INFO_VAMPIRE_SPEEDBONUS")
	elseif (option == JumpRankRateSlider)
		SetInfoText("$VAT_INFO_JUMPRANKRATE")
	elseif (option == SprintRankRateSlider)
		SetInfoText("$VAT_INFO_SPRINTRANKRATE")
	elseif (option == SwimRankRateSlider)
		SetInfoText("$VAT_INFO_SWIMRANKRATE")
	elseif (option == RaceOption)
		SetInfoText("$VAT_INFO_ENABLERACEOPTIONS")
	elseif (option == SpeedBonusSliderVampire) || (option == JumpBonusSliderVampire)
		SetInfoText("$VAT_INFO_BONUSVAMPIRE")
	elseif (option == UninstallOption)
		SetInfoText("$VAT_INFO_UNINSTALL")
	elseif (option == VersionString)
		SetInfoText("Athletics Training v" + ver + ", created by Volek")
	endif
EndEvent